/*
	spiswitch.h
	Library for ADG1414 switch arrays.
	Pietro Maoddi // 28.02.2017 // pietro.maoddi@gmail.com
*/

#ifndef spiswitch_h
#define spiswitch_h

// DEBUG ---------------------------------------------------------------------

// INCLUDES ------------------------------------------------------------------
#include <SPI.h>

// MACROS --------------------------------------------------------------------

// DEFINES -------------------------------------------------------------------

// CLASSES -------------------------------------------------------------------

class SPISwitch
{
	public:
		SPISwitch(SPISettings spiSet, uint8_t pinCS, uint8_t pinReset, uint8_t nChips);
		Reset();
		Set(uint8_t nSwitch, bool state);
		SendConfiguration();
		PrintConfiguration();
		
	private:
		uint8_t pinSS, pinReset;
		uint8_t nChips;
		uint8_t *switchState;
		SPISettings settings;
};

#endif
