# -*- coding: utf-8 -*-
"""
Created on Thu Apr 06 12:15:37 2017

@author: valeruozi
"""

import serial
import time

baudrate = 115200

MSG_OK = "ok"
MSG_ERROR = "error"
MSG_DELIMITER = "\r\n"
NCMD = 9

TRAP_LEFT = 'l'
TRAP_RIGHT = 'r'
TRAP_LEFT_MAX = 20
TRAP_RIGHT_MAX = 19
TRAP_ID_A = 'a'
TRAP_ID_B = 'b'
TRAP_N = (2*(TRAP_LEFT_MAX+TRAP_RIGHT_MAX))
TRAP_CMD_ALL = "all"


class PCB:
    def __init__(self,port):
        self.port = port
        self.baudrate = 115200
        self.answer = " "

        if self.answer == "error":
            self.error()

    def open_serial(self):
        self.arduino = serial.Serial(self.port, self.baudrate, timeout=.1)

    def close_serial(self):
        self.arduino.close()

    def get_on(self):
        self.command = "on"
        self.arduino.write(self.command + MSG_DELIMITER)
        time.sleep(0.1)
        line1 = self.arduino.readline()[:-4] # the last bit gets rid of the new-line chars and ok
        self.answer = line1
        return self.answer

    def set_on(self, value):
        if value == "all":
            self.command = "on all"
            self.arduino.write(self.command + MSG_DELIMITER)
            time.sleep(0.1)
            line1 = self.arduino.readline()
            line2 = self.arduino.readline()
            ok = self.arduino.readline()
            self.answer = line1 + line2
        else:
            self.command = "on " + value
            self.arduino.write(self.command + MSG_DELIMITER)
            time.sleep(0.1)
            line1 = self.arduino.readline()
            line2 = self.arduino.readline()
            ok = self.arduino.readline()
            self.answer = line1 + line2
        return self.answer

    def get_off(self):
        self.command = "off"
        self.command = self.arduino.write(self.command + MSG_DELIMITER)
        time.sleep(0.1)
        line1 = self.arduino.readline()[:-4]  # the last bit gets rid of the new-line chars and ok
        self.answer = line1
        return self.answer

    def set_off(self, value):
        if value == "all":
            self.command = "off all"
            self.arduino.write(self.command + MSG_DELIMITER)
            time.sleep(0.1)
            line1 = self.arduino.readline()
            line2 = self.arduino.readline()
            ok = self.arduino.readline()
            self.answer = line1 + line2
        else:
            self.command = "off " + value
            self.arduino.write(self.command + MSG_DELIMITER)
            time.sleep(0.1)
            line1 = self.arduino.readline()
            line2 = self.arduino.readline()
            ok = self.arduino.readline()
            self.answer = line1 + line2
        return self.answer

    def set_only(self,value):
        if value == "short":
            self.command = "short"
            self.arduino.write(self.command + MSG_DELIMITER)
            time.sleep(0.1)
            line1 = self.arduino.readline()
            line2 = self.arduino.readline()
            ok = self.arduino.readline()
            self.answer = line1 + line2
        elif value == "open":
            self.command = "open"
            self.arduino.write(self.command + MSG_DELIMITER)
            time.sleep(0.1)
            line1 = self.arduino.readline()
            line2 = self.arduino.readline()
            ok = self.arduino.readline()
            self.answer = line1 + line2
        else:
            self.command = "only " + value
            self.arduino.write(self.command + MSG_DELIMITER)
            time.sleep(0.1)
            line1 = self.arduino.readline()
            line2 = self.arduino.readline()
            ok = self.arduino.readline()
            self.answer = line1 + line2
        return self.answer

    def get_status(self):
        self.command = "status"
        self.arduino.write(self.command + MSG_DELIMITER)
        time.sleep(0.1)
        line = []
        for i in range(0,81):
            line.append(self.arduino.readline()[:-2]) # the last bit gets rid of the new-line chars
        self.answer = line
        return line

    def get_abus(self):
        self.command = "abus"
        self.arduino.write(self.command + MSG_DELIMITER)
        time.sleep(0.1)
        line1 = self.arduino.readline()[:-2] # the last bit gets rid of the new-line chars and ok
        self.answer = line1
        return self.answer


    def set_abus(self, value):
        self.command = "abus " + value
        self.arduino.write(self.command + MSG_DELIMITER)
        time.sleep(0.1)
        line1 = self.arduino.readline()[:-2]
        self.answer = line1
        return self.answer

    def get_acom(self):
        self.command = "acom"
        self.arduino.write(self.command + MSG_DELIMITER)
        time.sleep(0.1)
        line1 = self.arduino.readline()[:-2] # the last bit gets rid of the new-line chars and ok
        self.answer = line1
        return self.answer


    def set_acom(self, value):
        self.command = "acom " + value
        self.arduino.write(self.command + MSG_DELIMITER)
        time.sleep(0.1)
        line1 = self.arduino.readline()[:-2]
        self.answer = line1
        return self.answer

    def get_bias(self):
        self.command = "bias"
        self.arduino.write(self.command + MSG_DELIMITER)
        time.sleep(0.1)
        line1 = self.arduino.readline()[:-2] # the last bit gets rid of the new-line chars and ok
        self.answer = line1
        return self.answer


    def set_bias(self, value):
        self.command = "bias " + value
        self.arduino.write(self.command + MSG_DELIMITER)
        time.sleep(0.1)
        line1 = self.arduino.readline()[:-2]
        self.answer = line1
        return self.answer

    def set_mode(self, value):
        self.command = "mode " + value
        self.arduino.write(self.command + MSG_DELIMITER)
        time.sleep(0.1)
        line1 = self.arduino.readline()[:-2]
        self.answer = line1 + "\n"
        return self.answer

    def error(self):
        print "Wrong command"

#
#port = 'COM8'
##
#board = PCB(port)
#board.open_serial()
##
###result = board.set_off("all")
###print result
###result = board.set_only("l12a")
###print result
#result = board.set_mode("exc")
#print result
##result = board.set_on("l01a")
##print result
#
##result = board.get_status()
##print result
#board.close_serial()

